Index: src/uk/me/parabola/mkgmap/osmstyle/StyledConverter.java
===================================================================
--- src/uk/me/parabola/mkgmap/osmstyle/StyledConverter.java	(revision 3003)
+++ src/uk/me/parabola/mkgmap/osmstyle/StyledConverter.java	(working copy)
@@ -882,15 +882,21 @@
 		
 		if(relation instanceof RestrictionRelation) {
 			RestrictionRelation rr = (RestrictionRelation)relation;
-			if(rr.isValid() && bbox.contains(rr.getViaCoord())) {
-				List<RestrictionRelation> lrr = restrictions.get(rr.getViaCoord());
-				if(lrr == null) {
-					lrr = new ArrayList<RestrictionRelation>();
-					Coord via = rr.getViaCoord();
-					via.setViaNodeOfRestriction(true);
-					restrictions.put(via, lrr);
+			if(!rr.isValid())
+				log.error("Invalid rel: "+rr.toBrowseURL());
+			else {
+				if (bbox.contains(rr.getViaCoord())) {
+					List<RestrictionRelation> lrr = restrictions.get(rr.getViaCoord());
+					if(lrr == null) {
+						lrr = new ArrayList<RestrictionRelation>();
+						Coord via = rr.getViaCoord();
+						via.setViaNodeOfRestriction(true);
+						restrictions.put(via, lrr);
+					}
+					lrr.add(rr);
+				}else {
+					log.error("Via coord outside bbox: "+rr.toBrowseURL());
 				}
-				lrr.add(rr);
 			}
 		}
 		else if("through_route".equals(relation.getTag("type"))) {
Index: src/uk/me/parabola/mkgmap/reader/osm/RestrictionRelation.java
===================================================================
--- src/uk/me/parabola/mkgmap/reader/osm/RestrictionRelation.java	(revision 3003)
+++ src/uk/me/parabola/mkgmap/reader/osm/RestrictionRelation.java	(working copy)
@@ -287,6 +287,9 @@
 				toNode = fromNode;
 		}
 		if(restriction == null || viaNode == null || fromNode == null || toNode == null) {
+			// restriction must have some error (reported earlier)
+			log.error("Late invalid: "+toBrowseURL());
+			log.error(restriction+" "+viaNode+" "+fromNode+" "+toNode);
 			if (viaCoord != null)
 				log.warn("can't add restriction relation", this.getId(), "type", restriction);
 			return;
